Nogmaals hetzelfde mailtje, maar de bitmaps zijn vervangen door jpegs!:
Inmiddels heb ik ook gezien dat je een nieuwe release van mcam klaar hebt.

Hallo Jan,

Dit weekend ben ik verder gegaan met de creative webcamera.
Ik heb de sluitertijd nog verder kunnen rekken door via IIC de
clockdivisor in de sensor een ander deeltal te geven. De framerate
die je met SetFPS programmeert heeft tot gevolg dat de ASIC
een andere clock genereert voor de sensor. Tegelijkertijd past hij
intern de uitleesclock ook aan. Als je de interne divisor van de sensor
programmeert deelt hij de (eventueel al langzamere) clock van de ASIC
nog verder.
Dit heeft echter tot gevolg dat de datarate ook verandert, en de ASIC
kan dan de data niet meer lezen. Als je echter met IIC de clockrate van
de sensor weer terugzet is het eerstvolgende frame wat ingelezen kan
worden
het frame met lange sluitertijd. Dit komt omdat in de sensor intern het
deeltal
pas wordt geset aan het einde van een frame (of bij begin van volgend
frame).
Het heeft wel wat complicaties: Het werkt alleen zinvol met maximale
exposure
(R 255 511 x) (op zich geen probleem), en niet alle pixels hebben even
lang 'open'
gestaan,
wat komt door het op een andere snelheid uitlezen van de data.
De maximale sluitertijd die nu mogelijk is is met commando
SetSensorFPS(3, 0);
en de divisor in de sensor op 16 (minimaal 2, maximaal 16, dus relatief
deeltal=8),
(8*8)/25 = 2,56 seconde. Deze sluitertijd geldt alleen voor de bovenste
rij pixels.
De sluitertijd verloopt naar 8/25=0.32 seconde aan de onderkant van het
beeldje.
De resultaten die ik er mee heb kunnen verkrijgen zijn wel heel
bevredigend.
(zie attachment).
Voor het beeldje in de attachment heb ik de camera een middag in de
diepvries gelegd,
(<-20 graden), anders was het resultaat praktisch overstemd door ruis
(zie 2e
attachment).
Mischien is de onscherpte nog gedeeltelijk veroorzaakt door condens.
Ik heb ergens gezien dat men bij professionele CCD's voor een
sluitertijd van 1 seconde
koelt tot -30, en voor enkele minuten tot -170 graden. Ik weet alleen
nog niet waar ik
vloeibare stikstof vandaan moet halen om het uit te proberen. (Ik
betwijfel of de sensor

daar wel tegen kan, de specs geven als minimum 0 graden, en het eerste
beeldje als de
cam
uit de diepvries komt was gestreept (derde attachment)).

Het verder delen van de clock zou kunnen met hardware, maar de software
moet dan wel
het einde van een frame detecteren en dan de deler weer terugzetten om
de data uit te
lezen.
Mischien kan dit niet snel genoeg. Mooier zou het zijn als ik de
inleessnelheid van de
ASIC kon aanpassen aan de datasnelheid van de sensor. Dit is mischien
onderwerp voor
een mailtje aan Vision. Mischien is met een system call of een register
write mogelijk
de
clock gewoon nog verder omlaag te brengen.

Er zitten wel alvast een paar programmeerbare open pinnetjes aan de ASIC
voor hardware.

************************************

De toegevoegde code:

//     integerdeclaraties in main:
// added by NDJ
int grabmode;
int ccddivide;
int baseclk;
int framerate;

//      integer initialisatie:
// added by NDJ
ccddivide=0;
baseclk=1;
framerate=0;

//        kan bv geplaats worden onder de 'case '9'', weergeven beeld.
// added by NDJ
                case '0':  /* single frame grab */
   fprintf(stderr,\
   "single frame grab \n");
                        CPIA_SerialStart();         // setting ccd
divider to normal
                        CPIA_SerialWrite(0x20);
                        CPIA_SerialWrite(0x25);
                        CPIA_SerialWrite(0x00);
                        CPIA_SerialStop();
    /* get a frame from the camera into gStreamBuffer */
    if(! get_a_frame((int *)&actual_bytes, coding_mode) )
     {
     fprintf(stderr, "Get_a_frame failed\n");
     }

    /* insert display here */
    if(! display_a_frame(\
    argc, argv, actual_bytes, coding_mode, compression_flag) )
     {
     fprintf(stderr, "Display_a_frame failed\n");
     }

           CPIA_SetSensorFPS(framerate,baseclk); // restoring clk speed
   if (ccddivide) {
                        CPIA_SerialStart();
                        CPIA_SerialWrite(0x20);
                        CPIA_SerialWrite(0x25);
                        CPIA_SerialWrite(0x03);     // divider to 16
                        CPIA_SerialStop();
   }
             else {
                        CPIA_SerialStart();
                        CPIA_SerialWrite(0x20);
                        CPIA_SerialWrite(0x25);
                        CPIA_SerialWrite(0x00);    // divider to 2
                        CPIA_SerialStop();
   }
          break;
// added by NDJ
  case 'n':  /* toggle ccd divider contents */
            ccddivide=1-ccddivide;
   if (ccddivide) {fprintf(stderr, " changing ccd's divider to 16 ");
                        CPIA_SerialStart();
                        CPIA_SerialWrite(0x20);
                        CPIA_SerialWrite(0x25);
                        CPIA_SerialWrite(0x03);    // divider to 16
                        CPIA_SerialStop();
   }
             else {fprintf(stderr, "  changing ccd's divider to 2
(original) ");
                        CPIA_SerialStart();
                        CPIA_SerialWrite(0x20);
                        CPIA_SerialWrite(0x25);
                        CPIA_SerialWrite(0x00);     // divider to 2
                        CPIA_SerialStop();
   }

//          grabmode=1-grabmode;                    // grabmode getest
en voorlopig
zinloos gevonden
//   if (grabmode) {fprintf(stderr, " Setting grab mode to
'continuous'");}
//             else {fprintf(stderr, " Setting grab mode to 'single
frame grab'");}
//          CPIA_SetGrabMode (grabmode);
//   wait_key();
          break;

// added by NDJ
  case 'N':  /* change frame rate */
   fprintf(stderr,\
   "enter baserate (currently %d), 1=30fps, 0=25fps? \n",\
   baseclk);
   fscanf(stdin, "%d", &baseclk);
   fprintf(stderr,\
   "enter divisor (currently %d) 0=div1 1=div2 2=div4 3=div8 \n",\
   framerate);
   fscanf(stdin, "%d", &framerate);
           CPIA_SetSensorFPS(framerate,baseclk);
   wait_key();
          break;

*********************************

De IIC info heb ik van de site van Vision.
Na een single frame grab is de webcam in de war (de gain setting,
exposure, etc) en
krijg ik 'm weer normaal
zonder hem uit te zetten met de volgende toets sequence:

8 9 'enter' N 0 3 A a R 255 511 3
optioneel 9
n for divider to 16
0 for grab
X for save

Naast deze experimenten heb ik een adaptor gemaakt voor het plaatsen van
de ccd achter
een lens van een fototoestel.
Door het kleine CCD oppervlak (ik zeg voor het gemak maar steeds CCD) is
de vergroting
enorm, vooral met
een telelens (zie vierde attachment). Ik heb een zoomreeks bijgevoegd.
Het is me gelukt
de lens van de webcam verwijderbaar te maken zonder dat deze steeds
opengeschroefd hoeft
te worden .

De ingredienten voor astronomieexperimenten zijn er dus bijna allemaal!
Nu nog iets
bedenken voor koeling, maar
mischien lukt het met butaangas, of iets anders uit de winkel. Ik heb al
een leidinkje
gelegd door het optische compartiment langs de CCD.

Nog wat over mezelf: ik ben afgestudeerd student elektrotechniek, en nog
zoekend naar
werk.

Tot zover het verslag van m'n experimenten.

groeten,

Niels de Jong


